MBeanServerBuilder (Java SE 26 & JDK 26)
Description: declaration: module: java.management, package: javax.management, class: MBeanServerBuilder
Keywords: javax.management.MBeanServerBuilder class

# Class MBeanServerBuilder

java.lang.Object
javax.management.MBeanServerBuilder

public class MBeanServerBuilder extends Object

This class represents a builder that creates a default `MBeanServer` implementation. The JMX `MBeanServerFactory` allows applications to provide their custom MBeanServer implementation by providing a subclass of this class.

Since:
  1.5
See Also:
  - `MBeanServer`
  - `MBeanServerFactory`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MBeanServerBuilder()`
  Public default constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MBeanServer`
  `newMBeanServer(String defaultDomain, MBeanServer outer, MBeanServerDelegate delegate)`
  This method creates a new MBeanServer implementation object.
  `MBeanServerDelegate`
  `newMBeanServerDelegate()`
  This method creates a new MBeanServerDelegate for a new MBeanServer.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### MBeanServerBuilder

    public MBeanServerBuilder()
    Public default constructor.

- ## Method Details

  - ### newMBeanServerDelegate

    public MBeanServerDelegate newMBeanServerDelegate()
    This method creates a new MBeanServerDelegate for a new MBeanServer. When creating a new MBeanServer the `MBeanServerFactory` first calls this method in order to create a new MBeanServerDelegate.
    Then it calls `newMBeanServer(defaultDomain,outer,delegate)` passing the delegate that should be used by the MBeanServer implementation.

    Note that the passed delegate might not be directly the MBeanServerDelegate that was returned by this method. It could be, for instance, a new object wrapping the previously returned object.

    Returns:
      A new `MBeanServerDelegate`.

  - ### newMBeanServer

    public MBeanServer newMBeanServer(String defaultDomain, MBeanServer outer, MBeanServerDelegate delegate)
    This method creates a new MBeanServer implementation object. When creating a new MBeanServer the `MBeanServerFactory` first calls `newMBeanServerDelegate()` in order to obtain a new `MBeanServerDelegate` for the new MBeanServer. Then it calls `newMBeanServer(defaultDomain,outer,delegate)` passing the delegate that should be used by the MBeanServer implementation.

    Note that the passed delegate might not be directly the MBeanServerDelegate that was returned by this implementation. It could be, for instance, a new object wrapping the previously returned delegate.

    The outer parameter is a pointer to the MBeanServer that should be passed to the `MBeanRegistration` interface when registering MBeans inside the MBeanServer. If outer is `null`, then the MBeanServer implementation must use its own `this` reference when invoking the `MBeanRegistration` interface.

    This makes it possible for a MBeanServer implementation to wrap another MBeanServer implementation, in order to implement, e.g, security checks, or to prevent access to the actual MBeanServer implementation by returning a pointer to a wrapping object.

    Parameters:
      `defaultDomain` - Default domain of the new MBeanServer.
      `outer` - A pointer to the MBeanServer object that must be passed to the MBeans when invoking their `MBeanRegistration` interface.
      `delegate` - A pointer to the MBeanServerDelegate associated with the new MBeanServer. The new MBeanServer must register this MBean in its MBean repository.
    Returns:
      A new private implementation of an MBeanServer.